PrefixLines (Apache Ant API)
Date: 2018-03-24

org.apache.tools.ant.filters

## Class PrefixLines

- java.lang.Object
- - java.io.Reader
  - - java.io.FilterReader
    - - org.apache.tools.ant.filters.BaseFilterReader
      - - org.apache.tools.ant.filters.BaseParamFilterReader
        - - org.apache.tools.ant.filters.PrefixLines

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, java.lang.Readable, ChainableReader, Parameterizable

      public final class PrefixLines
      extends BaseParamFilterReader
      implements ChainableReader

  Attaches a prefix to every line. Example:

      <prefixlines prefix="Foo"/>

  Or:

      <filterreader classname="org.apache.tools.ant.filters.PrefixLines">
        <param name="prefix" value="Foo"/>
       </filterreader>

- - ### Field Summary

    - ### Fields inherited from class java.io.FilterReader

      `in`

    - ### Fields inherited from class java.io.Reader

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PrefixLines()` Constructor for "dummy" instances.
    `PrefixLines(java.io.Reader in)` Creates a new filtered reader.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.io.Reader` | `chain(java.io.Reader rdr)` Creates a new PrefixLines filter using the passed in Reader for instantiation.
    `int` | `read()` Returns the next character in the filtered stream.
    `void` | `setPrefix(java.lang.String prefix)` Sets the prefix to add at the start of each input line.

    - ### Methods inherited from class org.apache.tools.ant.filters.BaseParamFilterReader

      `getParameters, setParameters`

    - ### Methods inherited from class org.apache.tools.ant.filters.BaseFilterReader

      `getInitialized, getProject, read, readFully, readLine, setInitialized, setProject, skip`

    - ### Methods inherited from class java.io.FilterReader

      `close, mark, markSupported, ready, reset`

    - ### Methods inherited from class java.io.Reader

      `read, read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PrefixLines

          public PrefixLines()

      Constructor for "dummy" instances.
      See Also:
        `BaseFilterReader.BaseFilterReader()`

    - #### PrefixLines

          public PrefixLines(java.io.Reader in)

      Creates a new filtered reader.
      Parameters:
        `in` - A Reader object providing the underlying stream. Must not be `null`.

  - ### Method Detail

    - #### read

          public int read()
                   throws java.io.IOException

      Returns the next character in the filtered stream. One line is read from the original input, and the prefix added. The resulting line is then used until it ends, at which point the next original line is read, etc.
      Overrides:
        `read` in class `java.io.FilterReader`
      Returns:
        the next character in the resulting stream, or -1 if the end of the resulting stream has been reached
      Throws:
        `java.io.IOException` - if the underlying stream throws an IOException during reading

    - #### setPrefix

          public void setPrefix(java.lang.String prefix)

      Sets the prefix to add at the start of each input line.
      Parameters:
        `prefix` - The prefix to add at the start of each input line. May be `null`, in which case no prefix is added.

    - #### chain

          public java.io.Reader chain(java.io.Reader rdr)

      Creates a new PrefixLines filter using the passed in Reader for instantiation.
      Specified by:
        `chain` in interface `ChainableReader`
      Parameters:
        `rdr` - A Reader object providing the underlying stream. Must not be `null`.
      Returns:
        a new filter based on this configuration, but filtering the specified reader